function [tout, yout] = ab5semn(FunFcn,t0,tfinal,step,y0)
% ab5sem.m Costant Stepsize
% Adams Bashforth 5 step Explicit Method order 5
% calls rk4 for 4 steps
beta =  [251 -1274  2616 -2774  1901  ]/720;
stages=5;
[tout,yout]=rk4(FunFcn,t0,t0+(stages-1)*step,step,y0);
tout=tout(1:stages);
yout=yout(1:stages);
fout=feval(FunFcn,tout(1:stages),yout(1:stages));
t = tout(stages);
y = yout(stages).';
% The main loop
while abs(t- tfinal)> 1e-6 
   if t + step > tfinal, step = tfinal - t; end 
   y=y+step* beta*[fout(length(fout)-stages+1:length(fout))]; 
   t = t + step;
   f=feval(FunFcn,t,y);
   tout = [tout; t];
   yout = [yout; y.'];
   fout= [fout; f.'];
end;

